"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LqlProvider = void 0;

var _react = _interopRequireDefault(require("react"));

var _context = require("./context");

var LqlProvider = function LqlProvider(_ref) {
  var endpointUrl = _ref.endpointUrl,
      children = _ref.children;
  var LqlContext = (0, _context.getLqlContext)();
  return /*#__PURE__*/_react["default"].createElement(LqlContext.Consumer, null, function () {
    var context = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (endpointUrl && context.endpointUrl !== endpointUrl) {
      context = Object.assign({}, context, {
        endpointUrl: endpointUrl
      });
    }

    if (!context.endpointUrl) {
      throw new Error('LqlProvider was not passed endpointUrl: ' + JSON.stringify(context));
    }

    return /*#__PURE__*/_react["default"].createElement(LqlContext.Provider, {
      value: context
    }, children);
  });
};

exports.LqlProvider = LqlProvider;