"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useGraphqlClient = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _graphqlRequest = require("graphql-request");

var _context = require("./context");

var useGraphqlClient = function useGraphqlClient() {
  var _useState = (0, _react.useState)(null),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      endpointUrl = _useState2[0],
      setEndpointUrl = _useState2[1];

  var _useState3 = (0, _react.useState)({}),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      headers = _useState4[0],
      setHeaders = _useState4[1];

  var context = (0, _react.useContext)((0, _context.getLqlContext)());

  if (!context || !context.endpointUrl) {
    throw new Error('Missing LqlProvider');
  }

  if (endpointUrl != context.endpointUrl) {
    setEndpointUrl(context.endpointUrl);
  }

  if (JSON.stringify(headers) != JSON.stringify(context.headers)) {
    setHeaders(context.headers);
  }

  var graphqlClient = (0, _react.useMemo)(function () {
    return endpointUrl ? new _graphqlRequest.GraphQLClient(endpointUrl, {
      headers: headers
    }) : null;
  }, [headers, endpointUrl]);
  return graphqlClient;
};

exports.useGraphqlClient = useGraphqlClient;