"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useIntrospection = useIntrospection;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _reactQuery = require("react-query");

var _introspectron = require("introspectron");

var _noop = _interopRequireDefault(require("lodash/noop"));

var _useGraphqlClient = require("./use-graphql-client");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function useIntrospection() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var headers = options.headers,
      _options$onSuccess = options.onSuccess,
      onSuccess = _options$onSuccess === void 0 ? _noop["default"] : _options$onSuccess,
      _options$onError = options.onError,
      onError = _options$onError === void 0 ? _noop["default"] : _options$onError,
      restOptions = (0, _objectWithoutProperties2["default"])(options, ["headers", "onSuccess", "onError"]);
  var graphqlClient = (0, _useGraphqlClient.useGraphqlClient)();
  (0, _react.useEffect)(function () {
    if (headers && graphqlClient) {
      graphqlClient.setHeaders(headers);
    }
  }, [graphqlClient, headers]);

  var _useQuery = (0, _reactQuery.useQuery)('introspection', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var introspectionResults, _parseGraphQuery, queries, mutations;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return graphqlClient.request(_introspectron.IntrospectionQuery);

          case 2:
            introspectionResults = _context.sent;
            _context.prev = 3;
            _parseGraphQuery = (0, _introspectron.parseGraphQuery)(introspectionResults), queries = _parseGraphQuery.queries, mutations = _parseGraphQuery.mutations;
            return _context.abrupt("return", _objectSpread(_objectSpread({}, queries), mutations));

          case 8:
            _context.prev = 8;
            _context.t0 = _context["catch"](3);
            throw new Error('useIntrospection: failed to get introspection query');

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[3, 8]]);
  })), _objectSpread(_objectSpread({
    onError: onError,
    onSuccess: onSuccess
  }, restOptions), {}, {
    // The query will not execute until the graphqlClient exists
    enabled: !!graphqlClient,
    // SQL schema rarely changes, so we don't want it to invalidate too often
    refetchInterval: false,
    refetchIntervalInBackground: false,
    refetchOnMount: false,
    refetchOnWindowFocus: false
  })),
      refetch = _useQuery.refetch,
      rest = (0, _objectWithoutProperties2["default"])(_useQuery, ["refetch"]);

  return _objectSpread({
    refetch: refetch
  }, rest);
}