"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useLaunchqlClient = useLaunchqlClient;

var _react = require("react");

var _launchqlClient = require("launchql-client");

var _useIntrospection = require("./use-introspection");

var _useSchemaMeta = require("./use-schema-meta");

function useLaunchqlClient() {
  var introspection = (0, _useIntrospection.useIntrospection)();
  var meta = (0, _useSchemaMeta.useSchemaMeta)();
  return (0, _react.useMemo)(function () {
    if (!meta.data || !introspection.data) return null;
    return new _launchqlClient.Client({
      meta: _launchqlClient.MetaObject.convertFromMetaSchema({
        _meta: meta.data
      }),
      introspection: introspection.data
    });
  }, [introspection.data, meta.data]);
}