"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSchemaMeta = useSchemaMeta;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = require("react");

var _graphqlRequest = require("graphql-request");

var _reactQuery = require("react-query");

var _useGraphqlClient = require("./use-graphql-client");

var _templateObject;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var fieldFragment = "\n  name\n  type {\n    gqlType\n    isArray\n    modifier\n    pgAlias\n    pgType\n    subtype\n    typmod\n  }\n";
var queryFragment = "\n  query {\n    all\n    create\n    delete\n    one\n    update\n  }\n";
var primaryConstraintsFragment = "\n  primaryKeyConstraints {\n    name\n    fields {\n      ".concat(fieldFragment, "\n    }\n  }\n");
var foreignKeyConstraintsFragments = "\n  foreignKeyConstraints {\n    name\n    fields {\n      ".concat(fieldFragment, "\n    }\n    refFields {\n      ").concat(fieldFragment, "\n    }\n    refTable {\n      name\n    }\n  }\n");
var inflectionFragment = "\n  inflection {\n    allRows\n    allRowsSimple\n    conditionType\n    connection\n    createField\n    createInputType\n    createPayloadType\n    deleteByPrimaryKey\n    deletePayloadType\n    edge\n    edgeField\n    enumType\n    filterType\n    inputType\n    orderByType\n    patchField\n    patchType\n    tableFieldName\n    tableType\n    typeName\n    updateByPrimaryKey\n    updatePayloadType\n  }\n";
var metaQuery = (0, _graphqlRequest.gql)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2["default"])(["\n  query SchemaMetaQuery {\n    _meta {\n      tables {\n        name\n        ", "\n\n        ", "\n\n        fields {\n          ", "\n        }\n\n        ", "\n\n        ", "\n\n        uniqueConstraints {\n          name\n          fields {\n            ", "\n          }\n        }\n\n        relations {\n          belongsTo {\n            fieldName\n            isUnique\n            type\n            keys {\n              ", "\n            }\n            references {\n              name\n              fields {\n                ", "\n              }\n            }\n          }\n          has {\n            fieldName\n            isUnique\n            type\n            keys {\n              ", "\n            }\n            referencedBy {\n              name\n              fields {\n                ", "\n              }\n              ", "\n              ", "\n            }\n          }\n          hasMany {\n            fieldName\n            isUnique\n            type\n            keys {\n              ", "\n            }\n            referencedBy {\n              name\n              fields {\n                ", "\n              }\n              ", "\n              ", "\n            }\n          }\n          hasOne {\n            fieldName\n            isUnique\n            type\n            keys {\n              ", "\n            }\n            referencedBy {\n              name\n              fields {\n                ", "\n              }\n              ", "\n              ", "\n            }\n          }\n          manyToMany {\n            fieldName\n            type\n            leftKeyAttributes {\n              ", "\n            }\n            rightKeyAttributes {\n              ", "\n            }\n            junctionTable {\n              name\n              fields {\n                ", "\n              }\n              ", "\n              ", "\n              ", "\n            }\n            rightTable {\n              name\n              fields {\n                ", "\n              }\n              ", "\n              ", "\n              ", "\n            }\n          }\n        }\n      }\n    }\n  }\n"])), queryFragment, inflectionFragment, fieldFragment, primaryConstraintsFragment, foreignKeyConstraintsFragments, fieldFragment, fieldFragment, fieldFragment, fieldFragment, fieldFragment, primaryConstraintsFragment, foreignKeyConstraintsFragments, fieldFragment, fieldFragment, primaryConstraintsFragment, foreignKeyConstraintsFragments, fieldFragment, fieldFragment, primaryConstraintsFragment, foreignKeyConstraintsFragments, fieldFragment, fieldFragment, fieldFragment, queryFragment, primaryConstraintsFragment, foreignKeyConstraintsFragments, fieldFragment, queryFragment, primaryConstraintsFragment, foreignKeyConstraintsFragments);

function useSchemaMeta() {
  var _data$_meta;

  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var tableName = _ref.tableName,
      onSuccess = _ref.onSuccess,
      onError = _ref.onError,
      headers = _ref.headers,
      restOptions = (0, _objectWithoutProperties2["default"])(_ref, ["tableName", "onSuccess", "onError", "headers"]);
  var graphqlClient = (0, _useGraphqlClient.useGraphqlClient)();
  (0, _react.useEffect)(function () {
    if (headers && graphqlClient) {
      graphqlClient.setHeaders(headers);
    }
  }, [graphqlClient, headers]);

  var _useQuery = (0, _reactQuery.useQuery)('schemaMeta', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return graphqlClient.request(metaQuery);

          case 2:
            return _context.abrupt("return", _context.sent);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), _objectSpread(_objectSpread({
    onError: onError,
    onSuccess: onSuccess
  }, restOptions), {}, {
    // The query will not execute until the graphqlClient exists
    enabled: !!graphqlClient,
    // SQL schema rarely changes, so we don't want it to invalidate too often
    refetchInterval: false,
    refetchIntervalInBackground: false,
    refetchOnMount: false,
    refetchOnWindowFocus: false
  })),
      data = _useQuery.data,
      refetch = _useQuery.refetch,
      otherProps = (0, _objectWithoutProperties2["default"])(_useQuery, ["data", "refetch"]);

  return _objectSpread(_objectSpread({}, otherProps), {}, {
    refetch: refetch,
    data: tableName ? data === null || data === void 0 ? void 0 : (_data$_meta = data._meta) === null || _data$_meta === void 0 ? void 0 : _data$_meta.tables[tableName] : data === null || data === void 0 ? void 0 : data._meta
  });
}