"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTableRowsPaginated = useTableRowsPaginated;
exports.useTableRowsInfinite = useTableRowsInfinite;
exports.useCreateTableRow = useCreateTableRow;
exports.useDeleteTableRow = useDeleteTableRow;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _reactQuery = require("react-query");

var _useGraphqlClient = require("./use-graphql-client");

var _useLaunchqlClient = require("./use-launchql-client");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var noop = function noop() {};

function useTableRowsPaginated() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var tableName = options.tableName,
      first = options.first,
      after = options.after,
      last = options.last,
      before = options.before,
      condition = options.condition,
      filter = options.filter,
      orderBy = options.orderBy,
      _options$onSuccess = options.onSuccess,
      onSuccess = _options$onSuccess === void 0 ? noop : _options$onSuccess,
      onError = options.onError,
      _options$skip = options.skip,
      skip = _options$skip === void 0 ? false : _options$skip,
      select = options.select,
      restOptions = (0, _objectWithoutProperties2["default"])(options, ["tableName", "first", "after", "last", "before", "condition", "filter", "orderBy", "onSuccess", "onError", "skip", "select"]);
  var graphqlClient = (0, _useGraphqlClient.useGraphqlClient)();
  var lqlClient = (0, _useLaunchqlClient.useLaunchqlClient)();
  var graphqlQuery = (0, _react.useMemo)(function () {
    if (!lqlClient) return null;
    var result = lqlClient.query(tableName).getMany({
      select: select
    }).print();
    return {
      hash: result._hash,
      key: result._key
    };
  }, [lqlClient, select, tableName]);
  var params = (0, _react.useMemo)(function () {
    return {
      skip: skip,
      first: first,
      after: after,
      last: last,
      before: before,
      condition: condition,
      filter: filter,
      orderBy: orderBy,
      graphqlQuery: graphqlQuery
    };
  }, [after, before, condition, filter, first, graphqlQuery, last, orderBy, skip]);
  var query = (0, _reactQuery.useQuery)([tableName, params], /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(_ref) {
      var queryKey, _queryKey, params, _normalize, skip, first, last, after, before, condition, filter, orderBy, graphqlQuery, result;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              queryKey = _ref.queryKey;
              _queryKey = (0, _slicedToArray2["default"])(queryKey, 2), params = _queryKey[1];
              _normalize = normalize(params), skip = _normalize.skip, first = _normalize.first, last = _normalize.last, after = _normalize.after, before = _normalize.before, condition = _normalize.condition, filter = _normalize.filter, orderBy = _normalize.orderBy, graphqlQuery = _normalize.graphqlQuery;

              if (!(skip || !graphqlQuery)) {
                _context.next = 5;
                break;
              }

              return _context.abrupt("return", null);

            case 5:
              _context.next = 7;
              return graphqlClient.request(graphqlQuery.hash, {
                first: first,
                last: last,
                after: after,
                before: before,
                condition: condition,
                filter: filter,
                orderBy: orderBy
              });

            case 7:
              result = _context.sent;
              return _context.abrupt("return", result[graphqlQuery.key]);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }(), _objectSpread({
    onError: onError,
    onSuccess: onSuccess,
    enabled: !!graphqlClient && !!graphqlQuery
  }, restOptions));
  return query;
}

function useTableRowsInfinite() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var tableName = options.tableName,
      condition = options.condition,
      filter = options.filter,
      orderBy = options.orderBy,
      _options$onSuccess2 = options.onSuccess,
      onSuccess = _options$onSuccess2 === void 0 ? noop : _options$onSuccess2,
      onError = options.onError,
      select = options.select,
      restOptions = (0, _objectWithoutProperties2["default"])(options, ["tableName", "condition", "filter", "orderBy", "onSuccess", "onError", "select"]);
  var graphqlClient = (0, _useGraphqlClient.useGraphqlClient)();
  var lqlClient = (0, _useLaunchqlClient.useLaunchqlClient)();
  var graphqlQuery = (0, _react.useMemo)(function () {
    if (!lqlClient) return null;
    var result = lqlClient.query(tableName).getMany({
      select: select
    }).print();
    return {
      hash: result._hash,
      key: result._key
    };
  }, [lqlClient, select, tableName]);
  var params = (0, _react.useMemo)(function () {
    return {
      graphqlQuery: graphqlQuery,
      condition: condition,
      filter: filter,
      orderBy: orderBy
    };
  }, [condition, filter, graphqlQuery, orderBy]);
  var infiniteQuery = (0, _reactQuery.useInfiniteQuery)([tableName, params], /*#__PURE__*/function () {
    var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(_ref3) {
      var queryKey, _ref3$pageParam, pageParam, _queryKey2, params, _normalize2, condition, filter, orderBy, graphqlQuery, result;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              queryKey = _ref3.queryKey, _ref3$pageParam = _ref3.pageParam, pageParam = _ref3$pageParam === void 0 ? null : _ref3$pageParam;
              _queryKey2 = (0, _slicedToArray2["default"])(queryKey, 2), params = _queryKey2[1];
              _normalize2 = normalize(params), condition = _normalize2.condition, filter = _normalize2.filter, orderBy = _normalize2.orderBy, graphqlQuery = _normalize2.graphqlQuery;

              if (graphqlQuery) {
                _context2.next = 5;
                break;
              }

              return _context2.abrupt("return", null);

            case 5:
              _context2.next = 7;
              return graphqlClient.request(graphqlQuery.hash, {
                first: 50,
                after: pageParam,
                condition: condition,
                filter: filter,
                orderBy: orderBy
              });

            case 7:
              result = _context2.sent;
              return _context2.abrupt("return", result[graphqlQuery.key]);

            case 9:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x2) {
      return _ref4.apply(this, arguments);
    };
  }(), _objectSpread({
    onError: onError,
    onSuccess: onSuccess,
    enabled: !!graphqlClient && !!graphqlQuery,
    getNextPageParam: function getNextPageParam(lastPage) {
      return lastPage.pageInfo.endCursor;
    }
  }, restOptions));
  return infiniteQuery;
}

function useCreateTableRow() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var tableName = options.tableName,
      _onSuccess = options.onSuccess,
      onError = options.onError;
  var queryClient = (0, _reactQuery.useQueryClient)();
  var graphqlClient = (0, _useGraphqlClient.useGraphqlClient)();
  var lqlClient = (0, _useLaunchqlClient.useLaunchqlClient)();
  var graphqlMutation = (0, _react.useMemo)(function () {
    if (!lqlClient) return null;
    var result = lqlClient.query(tableName).create().print();
    return {
      hash: result._hash,
      key: result._key
    };
  }, [lqlClient, tableName]);
  var mutation = (0, _reactQuery.useMutation)( /*#__PURE__*/function () {
    var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(variables) {
      var result;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return graphqlClient.request(graphqlMutation.hash, variables);

            case 2:
              result = _context3.sent;
              return _context3.abrupt("return", result[graphqlMutation.key]);

            case 4:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x3) {
      return _ref5.apply(this, arguments);
    };
  }(), {
    onSuccess: function onSuccess() {
      // Will invalidate every query that has query key starting with tableName
      // ex: ['Action'] and ['Action', params] will both be invalidated
      queryClient.invalidateQueries(tableName);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (typeof _onSuccess === 'function') _onSuccess(args);
    },
    onError: onError
  });
  return mutation;
}

function useDeleteTableRow() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var tableName = options.tableName,
      _onSuccess2 = options.onSuccess,
      onError = options.onError;
  var queryClient = (0, _reactQuery.useQueryClient)();
  var graphqlClient = (0, _useGraphqlClient.useGraphqlClient)();
  var lqlClient = (0, _useLaunchqlClient.useLaunchqlClient)();
  var graphqlMutation = (0, _react.useMemo)(function () {
    if (!lqlClient) return null;
    var result = lqlClient.query(tableName)["delete"]().print();
    return {
      hash: result._hash,
      key: result._key
    };
  }, [lqlClient, tableName]);
  var mutation = (0, _reactQuery.useMutation)( /*#__PURE__*/function () {
    var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(variables) {
      var result;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return graphqlClient.request(graphqlMutation.hash, variables);

            case 2:
              result = _context4.sent;
              return _context4.abrupt("return", result[graphqlMutation.key]);

            case 4:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x4) {
      return _ref6.apply(this, arguments);
    };
  }(), {
    onSuccess: function onSuccess() {
      // Will invalidate every query that has query key starting with tableName
      // ex: ['Action'] and ['Action', params] will both be invalidated
      queryClient.invalidateQueries(tableName);

      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      if (typeof _onSuccess2 === 'function') _onSuccess2(args);
    },
    onError: onError
  });
  return mutation;
}

function normalize(params) {
  return _objectSpread(_objectSpread({}, params), {}, {
    after: params.after ? String(params.after) : null,
    before: params.before ? String(params.before) : null,
    first: isValidPageSize(params.first) ? undefined : Number(params.first),
    last: isValidPageSize(params.last) ? undefined : Number(params.last)
  });
}

function isValidPageSize(size) {
  return isNaN(size) || size == null;
}