import React from 'react';
import { getLqlContext } from './context';
export const LqlProvider = ({
  endpointUrl,
  children
}) => {
  const LqlContext = getLqlContext();
  return /*#__PURE__*/React.createElement(LqlContext.Consumer, null, (context = {}) => {
    if (endpointUrl && context.endpointUrl !== endpointUrl) {
      context = Object.assign({}, context, {
        endpointUrl
      });
    }

    if (!context.endpointUrl) {
      throw new Error('LqlProvider was not passed endpointUrl: ' + JSON.stringify(context));
    }

    return /*#__PURE__*/React.createElement(LqlContext.Provider, {
      value: context
    }, children);
  });
};