import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import { useEffect } from 'react';
import { useQuery } from 'react-query';
import { IntrospectionQuery, parseGraphQuery } from 'introspectron';
import noop from 'lodash/noop';
import { useGraphqlClient } from './use-graphql-client';
export function useIntrospection(options = {}) {
  const {
    headers,
    onSuccess = noop,
    onError = noop
  } = options,
        restOptions = _objectWithoutProperties(options, ["headers", "onSuccess", "onError"]);

  const graphqlClient = useGraphqlClient();
  useEffect(() => {
    if (headers && graphqlClient) {
      graphqlClient.setHeaders(headers);
    }
  }, [graphqlClient, headers]);

  const _useQuery = useQuery('introspection', async () => {
    const introspectionResults = await graphqlClient.request(IntrospectionQuery);

    try {
      const {
        queries,
        mutations
      } = parseGraphQuery(introspectionResults);
      return _objectSpread(_objectSpread({}, queries), mutations);
    } catch (err) {
      throw new Error('useIntrospection: failed to get introspection query');
    }
  }, _objectSpread(_objectSpread({
    onError,
    onSuccess
  }, restOptions), {}, {
    // The query will not execute until the graphqlClient exists
    enabled: !!graphqlClient,
    // SQL schema rarely changes, so we don't want it to invalidate too often
    refetchInterval: false,
    refetchIntervalInBackground: false,
    refetchOnMount: false,
    refetchOnWindowFocus: false
  })),
        {
    refetch
  } = _useQuery,
        rest = _objectWithoutProperties(_useQuery, ["refetch"]);

  return _objectSpread({
    refetch
  }, rest);
}